// ***************************************
// Plugin View code for SourceBoost IDE
//
// Author(s): David Hobday
//
// Copyright (C) 2003-2010 Pavel Baranov
// Copyright (C) 2003-2010 David Hobday
// 
// This code may be freely used to develop
// Plugins for the SourceBoost IDE
// ***************************************

#ifndef _PLUGIN_VIEW_
#define _PLUGIN_VIEW_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PluginView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CPluginView form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CPluginView : public CFormView
{
public:
	enum { WMU_DATA_REQ_UPDATE = WM_USER };

	CPluginView();
	void Save( ostream& os ) {} // called at end of SourceBoost IDE session to allow GUI related setup to be saved
	void Load( istream& is ) {} // called at start of SourceBoost IDE session to allow GUI related setup to be restored
	
protected:
	
	DECLARE_DYNCREATE(CPluginView)

// Form Data
public:
	//{{AFX_DATA(CPluginView)
	enum { IDD = IDD_PLUGIN_FORMVIEW };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Attributes
public:

// Operations
public:
	virtual BOOL Create( LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPluginView)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnDraw(CDC* pDC);
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
public:

	CSliderCtrl* m_voltageSlider;
	CStatic* m_voltageDisplay;

	virtual ~CPluginView();
protected:
	
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CPluginView)
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:	
	void DisplayV();
	void SetSliderV( int Vmv );
	int GetSliderV();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // _PLUGIN_VIEW_
